package com.recovery.admin.boot.rest;


import com.recovery.admin.boot.service.IMemberUserService;
import com.recovery.admin.boot.service.ISysUserService;
import com.recovery.common.base.dto.MemberUserAuthDTO;
import com.recovery.common.base.dto.UserAuthDTO;
import com.recovery.common.base.enums.PasswordEncoderTypeEnum;
import com.recovery.common.base.result.ApiResult;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;

/**
 * @author： 
 */
@RestController
@RequestMapping("/api/rest/users")
@Slf4j
public class UserRest {

    @Resource
    private ISysUserService iSysUserService;
    @Resource
    private IMemberUserService memberUserService;

    /**
     * 获取用户信息
     */
    @GetMapping("/getUserByUsername")
    public ApiResult<UserAuthDTO> getUserByUsername(@RequestParam String username) {
        UserAuthDTO user = iSysUserService.getByUsername(username);
        if (user == null) {
            throw new RuntimeException();
        }
        return ApiResult.ok(user);
    }
    /**12
     * 获取会员用户信息
     */
    @GetMapping("/member/username/{username}")
    public ApiResult<MemberUserAuthDTO> getMemberUserByUsername(@PathVariable String username) {
        log.info("获取member user info。。。");
        MemberUserAuthDTO user = memberUserService.getByUsername(username);
        return ApiResult.ok(user);
    }
}
