package com.recovery.admin.boot.util;


import com.recovery.admin.boot.exception.BusinessException;
import com.recovery.common.base.constant.Constants;
import com.recovery.common.base.dto.UserAuthorityDto;
import com.recovery.common.base.result.ResultCode;
import com.recovery.common.base.util.RedisUtil;
import lombok.extern.slf4j.Slf4j;

import javax.servlet.http.HttpServletRequest;

@Slf4j
public class UserUtil {

    /**
     * 获取登录用户信息
     * @param request
     * @param redisUtil
     * @return
     */
    public static UserAuthorityDto getLoginUserInfo(HttpServletRequest request, RedisUtil redisUtil){
        String loginUserToken = (String) request.getHeader(Constants.LOGIN_USRE_TOKEN);
        Boolean rest =  redisUtil.hasKey("userToken:" +loginUserToken);
        log.info("缓存key："+"userToken:" +loginUserToken);
        log.info("缓存中是否有这条用户："+rest);
        if (!rest) {
            throw new BusinessException(ResultCode.TOKEN_INVALID_OR_EXPIRED);
        }
        UserAuthorityDto userAuthorityDto = (UserAuthorityDto) redisUtil.get("userToken:" +loginUserToken);
        return userAuthorityDto;
    }
}
